style_toggles = {
  'someone_liked': {
    'name': '<someone> liked',
    'rules': [
      '.tweet[data-component-context="suggest_activity_tweet"] { display: none; }'
    ]
  },
  'recycled': {
    'name': 'Recycled Tweets',
    'rules': [
      '.tweet[data-component-context="suggest_recycled_tweet_inline"] { display: none; }'
    ]
  },
}

button = '<li class="filter-nav dropdown" style="overflow: visible" id="filter-dropdown">\
<a id="filter-dropdown-toggle" class="btn dropdown-toggle js-dropdown-toggle" role="button" aria-haspopup="true">\
  <span class="Icon Icon--filter Icon--large"/>\
</a>\
<div class="filter-dropdown dropdown-menu" style="width: 192px;">\
  <div class="dropdown-caret">\
    <span class="caret-outer"></span>\
    <span class="caret-inner"></span>\
  </div>\
  <ul tabindex="-1" id="filter-toggles" role="menu" aria-labelledby="filter-dropdown-toggle" aria-hidden="true">\
    <li>Hide:</li>\
  </ul>\
</div>\
</li>'
document.querySelector('.dm-nav').insertAdjacentHTML('afterend', button)
document.querySelector('#filter-dropdown-toggle').addEventListener('click', function(evt) {
  document.querySelector('#filter-dropdown').classList.toggle('open')
})

var sheets = {}
var checks = {}

var storage;
if(typeof browser !== 'undefined') {
  storage = browser.storage.local
} else {
  storage = chrome.storage.local
}

for(t in style_toggles) {
  // Adapted from https://stackoverflow.com/a/524721/306323
  var style = document.createElement('style');
  var head = document.head || document.getElementsByTagName('head')[0];
  var css = style_toggles[t]['rules'].join("\n");

  sheets[t] = style;

  style.type = 'text/css';
  style.id = 'style_' + t;
  style.disabled = true;
  if (style.styleSheet){
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }

  head.appendChild(style);

  var check = document.createElement('input')   
  var label = document.createElement('label')   
  var li = document.createElement('li')
  check.type = "checkbox"
  check.checked = true
  check.value = t
  check.className = "activate-filter"
  label.innerText = " " + style_toggles[t].name
  label.insertBefore(check, label.firstChild)
  li.setAttribute('role','presentation')
  li.appendChild(label)
  document.querySelector('#filter-toggles').appendChild(li)

  checks[t] = check
}

storage.get(Object.keys(style_toggles), function(items) {
  for(t in items) {
    var enabled = items[t]
    console.log(items)
    if(t in checks) {
      sheets[t].disabled = !enabled
      checks[t].checked = enabled
    }
  }
})

document.querySelector('#filter-toggles').addEventListener('click', function(evt) {
  if(evt.target.tagName == 'INPUT') {
    var type = evt.target.value
    style = document.querySelector('#style_' + type)
    style.disabled = !evt.target.checked
    setobj = {}
    setobj[type] = evt.target.checked
    storage.set(setobj)
  }
})
